#!/bin/sh -e

if [ ! -x ./build/fwm-perfmon ]; then
  echo "compile first!"
  exit
fi

rm -Rf ./build/deb

mkdir ./build/deb

# place files
mkdir -p ./build/deb/usr/bin
cp -p ./build/fwm-perfmon ./build/deb/usr/bin/fwm-perfmon

# place controls
VERSION=`head -1 ./CHANGELOG.TXT | tr -d -`
ARCH=`dpkg --print-architecture`
SIZE=`du -k -s ./build/deb | awk '{print $1}'`
VER1=`dpkg-query -W -f='${Version}' libc6`
VER2=`dpkg-query -W -f='${Version}' libx11-6`
VER3=`dpkg-query -W -f='${Version}' libxext6`
if [ -n "$LOCAL_LIBFWM" ]; then
  VER4=`head -1 ../libfwm/CHANGELOG.TXT | tr -d -`
else
  VER4=`dpkg-query -W -f='${Version}' libfwm`
fi
mkdir ./build/deb/DEBIAN
( cd ./build/deb && md5deep -r -l usr) > ./build/deb/DEBIAN/md5sums
cat > ./build/deb/DEBIAN/control <<EOF
Package: fwm-perfmon
Version: $VERSION
Architecture: $ARCH
Maintainer: firk <firk@cantconnect.ru>
Installed-Size: $SIZE
Depends: libc6 (>= $VER1), libx11-6 (>= $VER2), libxext6 (>= $VER3), libfwm (>= $VER4)
Suggests: fwm
Section: utils
Priority: optional
Multi-Arch: foreign
Homepage: https://dev.m1089.ru/fwm-perfmon
Description: simple performance monitor for x11
EOF

fakeroot dpkg-deb --build ./build/deb ./build

rm -Rf ./build/deb

echo "DONE"
