#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "util.h"
#include "get_cpustat.h"


extern int get_cpustat(cpustat * r) {
  FILE * fp;
  char buf[4000];
  char *p, *pp;
  int idx;
  int ready[3];
  ull pr,pw,tia[10],ti,tt;
  cpustat rr;

  pr=pw=tt=0; for(idx=0;idx<10;idx++) tia[idx]=0;
  fp = fopen("/proc/stat", "rb");
  if(!fp) goto err;
  for(idx=0; idx<3; idx++) ready[idx]=0;
  while(fgets(buf, sizeof(buf), fp)) {
    p = buf;
    while(*p==' ' || *p=='\t') p++;
    for(pp=p; *pp && *pp!=' ' && *pp!='\t'; pp++);
    if(*pp!=' ' && *pp!='\t') continue;
    *pp = 0;
    if(!strcmp(p,"cpu")) idx=0;
    else if(!strcmp(p,"procs_running")) idx=1;
    else if(!strcmp(p,"procs_blocked")) idx=2;
    else continue;
    *pp = ' ';
    if(ready[idx]) { printf("duplicate %s\n",p); goto err2; }
    do { pp++; } while(*pp==' ' || *pp=='\t');
    ready[idx] = 1;
    switch(idx) {
    case 0:
      for(idx=0; idx<7; idx++) {
        if(idx && *(pp++)!=' ') goto parse_err;
        if(parse_ull(&pp, &ti)<0) goto parse_err;
        tt += ti;
        tia[idx] = ti;
      }
      for( ; *pp!='\n' || pp[1]; idx++) {
        if(*(pp++)!=' ') goto parse_err;
        if(parse_ull(&pp, &ti)<0) goto parse_err;
        tt += ti;
        if(idx<10) tia[idx] = ti;
      }
      break;
    case 1:
      if(parse_ull(&pp, &pr)<0) goto parse_err;
      if(strcmp(pp,"\n")) goto parse_err;
      break;
    case 2:
      if(parse_ull(&pp, &pw)<0) goto parse_err;
      if(strcmp(pp,"\n")) goto parse_err;
      break;
    default: parse_err: printf("parse err: <%s>\n", p); goto err2;
    }
  }
  fclose(fp);
  for(idx=0; idx<3; idx++) if(!ready[idx]) { printf("missing %d\n", idx); goto err; }
  r->ticks_total = tt;
  r->ticks_user = tia[0];
  r->ticks_nice = tia[1];
  r->ticks_system = tia[2];
  r->ticks_idle = tia[3];
  r->ticks_iowait = tia[4];
  r->ticks_irq = tia[5];
  r->ticks_softirq = tia[6];
  r->ticks_steal = tia[7];
  r->ticks_guest = tia[8];
  r->ticks_guest_nice = tia[9];
  r->procs_runnable = pr;
  r->procs_waiting_io = pw;
  return 0;
err2:
  fclose(fp);
err:
  return -1;
}


