#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "util.h"
#include "get_memstat.h"


extern int get_memstat(memstat * r) {
  FILE * fp;
  char buf[4000];
  char *p, *pp;
  int idx;
  int ready[10];
  ull vals[10];

  fp = fopen("/proc/meminfo", "rb");
  if(!fp) goto err;
  for(idx=0; idx<10; idx++) { ready[idx]=0; vals[idx]=0; }
  while(fgets(buf, sizeof(buf), fp)) {
    p = buf;
    while(*p==' ') p++;
    for(pp=p; *pp && *pp!=':'; pp++);
    if(*pp!=':') continue;
    *pp = 0;
    if(!strcmp(p,"MemTotal")) idx=0;
    else if(!strcmp(p,"MemFree")) idx=1;
    else if(!strcmp(p,"MemAvailable")) idx=2;
    else if(!strcmp(p,"Buffers")) idx=3;
    else if(!strcmp(p,"Cached")) idx=4;
    else if(!strcmp(p,"Active")) idx=5;
    else if(!strcmp(p,"Inactive")) idx=6;
    else if(!strcmp(p,"SwapTotal")) idx=7;
    else if(!strcmp(p,"SwapFree")) idx=8;
    else if(!strcmp(p,"SReclaimable")) idx=9;
    else continue;
    *pp = ':';
    if(ready[idx]) goto err2;
    for(pp++; *pp==' '; pp++);
    if(parse_ull(&pp, vals+idx)<0) { printf("parse err: <%s>\n", p); goto err2; }
    if(strcmp(pp," kB\n")) { printf("parse err: <%s>\n", p); goto err2; }
    ready[idx] = 1;
  }
  fclose(fp);
  for(idx=0; idx<10; idx++) if(!ready[idx]) goto err;
  r->total = vals[0];
  r->active = vals[5];
  r->inactive = vals[6];
  r->temp = vals[3]+vals[4]+vals[9];
  r->free = vals[1];
  r->avail = vals[2];
  r->swap_total = vals[7];
  r->swap_free = vals[8];
  return 0;
err2:
  fclose(fp);
err:
  return -1;
}


