
typedef int bps_t; /* set to long long for 10gbit+ links */
typedef uint ubps_t; /* set to ull for 10gbit+ links */

#define MAX_IFNAME 40
#define MAX_IFSEC 3600
typedef struct {
  char name[MAX_IFNAME];
  uint idle_time;
  uint missing_time;
  uint last_valid;
  uint next_valid;
  ull avg_bp10m;
  ull last_recv;
  ull last_sent;
  ull next_recv;
  ull next_sent;
  bps_t bps[MAX_IFSEC][2];
} if_stats;

#define MAX_IF 256
extern if_stats ifstats[MAX_IF];
extern uint ifstat_pos; /* ifstats[].bps[stat_pos] is a place immediately after last stored diff */

extern if_stats * get_if_by_name(char const *ifname, int may_create);
extern void update_ifstats(uint timediff);
